<?php
/**
 * Created by PhpStorm.
 * User: heyu
 * Date: 2019-05-08
 * Time: 09:13
 */

namespace kwy\sunmi\pay;


use kwy\sunmi\Request;

class SunmiPay
{
    use Request;

    private $host='http://test.openapi.sunmi.com/';

    private $app_id='71aefe05cd4c49b6acd1bd2715ed5577';
    private $app_key='d14e67c900c04e4d923a5ed2abfef05a';
    private $sid='2019050506465926';
    /**
     * @param string $host
     */
    public function setHost($host)
    {
        $this->host = $host;
    }

    /**
     * @param string $app_id
     */
    public function setAppId($app_id)
    {
        $this->app_id = $app_id;
    }

    /**
     * @param string $app_key
     */
    public function setAppKey($app_key)
    {
        $this->app_key = $app_key;
    }

    /**
     * @param string $sid
     */
    public function setSid($sid)
    {
        $this->sid = $sid;
    }


    /**
     * @param $sn
     * @param $sunmi_order_no
     * @return array
     * 'body'
     * 'subject'
     * 'status'   1-待支付 2-已支付 3-已退款
     * 'trade_date' 支付日期 2019-05-08T00:00:00Z
     * 'scene'  1-人脸 2-条码（BC） 3-条码（CB）
     * 'total_amount'  交易金额 分
     * 'sunmi_order_no'
     * 'merchant_order_no'
     * @throws \Exception
     */
    public function query($sn,$sunmi_order_no){
        $function='trade/query/';

        $data=[
            'msn'=>$sn,
            'sunmi_order_no'=>$sunmi_order_no,
        ];

        $result = $this->request($function,$data);
        //var_dump($result);
        if ($result['code']!=='10000'){
            throw new \Exception($result['msg']);
        }
        if (!empty($result['data']['sub_code'])){
            throw new \Exception($result['data']['sub_msg']);
        }
        return $result['data'];
    }

    /**
     * @param $sn
     * @param $refund_amount
     * @param $sunmi_order_no
     * @param $merchant_refund_no  商户端退款单号
     * @return array
     *
     * 'state'  1-待退款 2-交易超时关闭，或全额退款 3-已成功 4 -交易结束，不可退款 5-交易失败
     * 'pay_type'  （alipay、unionpay、wxpay）
     * 'platform'  支付通道 (alipay(支付宝)、unionpay(银联)、wxpay(微信))
     * 'refund_amount'
     * 'sunmi_order_no' 商米退款单号
     * @throws \Exception
     */
    public function refund($sn,$refund_amount,$sunmi_order_no,$merchant_refund_no){
        $function='trade/refund/';
        $data=[
            'msn'=>$sn,
            'refund_amount'=>$refund_amount,
            'sunmi_order_no'=>$sunmi_order_no,
            'merchant_business_no'=>$merchant_refund_no,
        ];
        $result = $this->request($function,$data);
        //var_dump($result);
        if ($result['code']!=='10000'){
            throw new \Exception($result['msg']);
        }
        if (isset($result['data']['sub_code'])){
            throw new \Exception($result['data']['sub_msg']);
        }
        return $result['data'];
    }

    protected function request($function,$data){
        $data=array_merge([
            'app_id'=>$this->app_id,
            'charset'=>'utf8',
        ],$data);
        $data['sign']=$this->getSign($data,$this->app_key);
        return $this->post($this->host.$function,http_build_query($data));
    }

    protected function getSign($data,$key){
        $str='';
        ksort($data);
        foreach ($data as $k=>$v){
            $str.=$k.'='.$v.'&';
        }
        $str=rtrim($str,'&').$key;
        return strtoupper(md5($str));
    }

}